#include "image.h"
#include "mem_arena.h"
#include <stddef.h>
#include <string.h>

Image *create_image(u64 width, u64 height, Pixel *data, Arena *arena) {
  if (!arena) {
    return NULL;
  }

  u64 buf_length = width * height;
  u64 total_size = sizeof(Image) + sizeof(Pixel) * buf_length;

  Image *img = wapp_mem_arena_alloc(arena, total_size);
  if (!img) {
    return NULL;
  }

  img->width = width;
  img->height = height;
  img->buf_length = buf_length;
  memcpy(img->data, data, buf_length);

  return img;
}
